ApplicationModel subclass: #GSPClassesExplorer
	instanceVariableNames: 'classes instances gInspector tempClassName classNames className '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSP- Classes Explorer'!


!GSPClassesExplorer methodsFor: 'actions'!

exploreClass
	"This stub method was generated by UIDefiner"

	self classes selection isNil ifFalse: 
			[self exploreInInspector: self selectedClass.
			self searchInstances]!

exploreInstance
	"This stub method was generated by UIDefiner"

	self instances selection isNil
		ifFalse: [self exploreInInspector: self instances selection]!

exploreMetaclass
	"This stub method was generated by UIDefiner"

	self classes selection isNil
		ifFalse: [self exploreInInspector: self selectedClass class]!

searchInstances
	"The receiver looks for and shows the current instances of the selected class."

	self classes selection isNil
		ifFalse: [self instances list: self selectedClass allInstances]! !

!GSPClassesExplorer methodsFor: 'aspects'!

classes
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."

	^classes!

className
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^className isNil
		ifTrue:
			[className := String new asValue]
		ifFalse:
			[className]!

instances
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."

	^instances! !

!GSPClassesExplorer methodsFor: 'private'!

changeCharacter: newCharacter 
	"This message is sent when the user presses a key on the quick search. "

	tempClassName := (self builder componentAt: #className) widget displayContents text string.
	newCharacter keyValue = Character backspace ifFalse: 
			[tempClassName := tempClassName , newCharacter keyValue asSymbol asString].
	self pointClassName!

exploreInInspector: anObject 
	" anObject is to be inspected. "

	self gInspector inspectedObject: anObject.
	self gInspector showInspectedObject!

pointClassName
	"The receiver shows the first class name that matches with the current text in the quick search. "

	| aClassName |
	aClassName := self classes list detect: 
					[:each | 
					(each asString findString: tempClassName
						startingAt: 1
						ignoreCase: true
						useWildcards: false) first = 1]
				ifNone: [nil].
	self classes selection: aClassName.
	self searchInstances!

selectedClass
	"The receiver returns the selected class. "

	^Smalltalk at: self classes selection!

showAllClasses
	self classes list: self classNames! !

!GSPClassesExplorer methodsFor: 'initialize-release'!

initialize
	classes := SelectionInList new.
	instances := SelectionInList new.
	self classNames: Smalltalk classNames.
	tempClassName := ''.
	self showAllClasses! !

!GSPClassesExplorer methodsFor: 'accessing'!

classNames
	^classNames!

classNames: anObject
	classNames := anObject!

gInspector
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^gInspector isNil
		ifTrue:
			[gInspector := GSPInspector new]
		ifFalse:
			[gInspector]! !

!GSPClassesExplorer methodsFor: 'interface opening'!

postOpenWith: aBuilder 
	self builder keyboardProcessor keyboardHook: 
			[:keyPressed :application | 
			application model changeCharacter: keyPressed.
			keyPressed].
	self builder keyboardProcessor
		processKeyboardFor: (aBuilder componentAt: #className) widget controller! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GSPClassesExplorer class
	instanceVariableNames: ''!


!GSPClassesExplorer class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#properties: #(#PropertyListDictionary ) 
			#label: 'Classes Explorer' 
			#min: #(#Point 40 20 ) 
			#bounds: #(#Rectangle 64 105 704 585 ) 
			#flags: 8 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#SubCanvasSpec 
					#layout: #(#LayoutFrame 0 0.345426 2 0 0 1.00158 0 1.0 ) 
					#name: #gInspector 
					#flags: 0 
					#majorKey: #GSPInspector 
					#minorKey: #windowSpec 
					#clientKey: #gInspector ) 
				#(#ActionButtonSpec 
					#layout: #(#LayoutFrame 2 0 0 0.635021 0 0.345426 0 0.685654 ) 
					#model: #exploreMetaclass 
					#label: 'Explore Metaclass' 
					#defaultable: true ) 
				#(#CompositeSpecCollection 
					#collection: #(
						#(#SequenceViewSpec 
							#layout: #(#LayoutFrame 0 0.0231481 0 0.144928 0 0.972222 0 0.956522 ) 
							#name: #instances 
							#model: #instances 
							#callbacksSpec: 
							#(#UIEventCallbackSubSpec 
								#focusInSelector: #exploreInstance 
								#valueChangeSelector: #exploreInstance ) 
							#useModifierKeys: true 
							#selectionType: #highlight ) 
						#(#GroupBoxSpec 
							#layout: #(#LayoutFrame 0 0.0 0 0.0 0 1.0 0 1.0 ) 
							#label: 'Current Instances' ) ) 
					#compositeSpec: 
					#(#CompositeSpec 
						#layout: #(#LayoutFrame 3 0 0 0.702532 0 0.347003 0 0.993671 ) ) ) 
				#(#CompositeSpecCollection 
					#collection: #(
						#(#SequenceViewSpec 
							#layout: #(#LayoutFrame 0 0.0230415 0 0.0748299 0 0.967742 0 0.829932 ) 
							#name: #classes 
							#model: #classes 
							#callbacksSpec: 
							#(#UIEventCallbackSubSpec 
								#valueChangeSelector: #exploreClass ) 
							#useModifierKeys: true 
							#selectionType: #highlight ) 
						#(#InputFieldSpec 
							#layout: #(#LayoutFrame 0 0.0230415 0 0.894558 0 0.976958 0 0.982993 ) 
							#name: #className 
							#model: #className ) 
						#(#LabelSpec 
							#layout: #(#LayoutOrigin 0 0.00921659 0 0.829932 ) 
							#label: 'Quick search' ) 
						#(#GroupBoxSpec 
							#layout: #(#LayoutFrame 0 0.0 0 0.0 0 1.0 0 1.0 ) 
							#label: 'Classes' ) ) 
					#compositeSpec: 
					#(#CompositeSpec 
						#layout: #(#LayoutFrame 0 0.00473186 0 -0.00421941 0 0.347003 0 0.616034 ) ) ) ) ) )! !

!GSPClassesExplorer class methodsFor: 'instance creation'!

new
	^super new initialize! !

!GSPClassesExplorer class methodsFor: 'parcel load/unload/save'!

preUnloadActionFor: theInstancesExplorerParcel 
	"A Parcel's pre-unload action must be a class method taking one 
	argument, the Parcel being unloaded. Fill-out this template and accept. 
	Note that you can give the method whatever selector you want. 
	You don't have to use preUnloadActionFor:. 
	
	The pre-unload action should ensure that the Parcel unloads cleanly. 
	This usually includes things like checking that any open applications 
	derived from the Parcel are closed, and that any long-lived data strutures 
	using instances of classes defined in the Parcel are emptied of those 
	instances. 
	
	ApplicationModel checkUnloadOfApplicationsDefinedBy: aParcel is provided 
	to close-down any open applications defined by a parcel."

	ApplicationModel checkUnloadOfApplicationsDefinedBy: theInstancesExplorerParcel.
	VisualLauncher removeSelector: #openClassesExplorer! !

